Merge pull request #2046 from rolfbjarne/profile-simplification
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = assemblyresolve gc-descriptors
2
3 check-local: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test-cattr-type-load test-reflection-load-with-context test_platform test-process-exit test-messages test-unhandled-exception-2 rm-empty-logs
4 check-full: test-sgen check-local
5 check-parallel: compile-tests check-full
6
7 # for backwards compatibility on Wrench
8 test-wrench: check-parallel
9
10 aotcheck: testaot gshared-aot
11
12 TEST_PROG = ../interpreter/mint
13
14 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
15
16 TEST_PROG_RUN = MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
17 JITTEST_PROG_RUN = MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
18
19 RUNTIME_ARGS=--config tests-config --optimize=all --debug
20
21 CLASS=$(mcs_topdir)/class/lib/$(DEFAULT_PROFILE)
22
23 with_mono_path = MONO_PATH=$(CLASS)
24
25 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
26
27 MKBUNDLE = \
28         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
29         $(RUNTIME) $(CLASS)/mkbundle.exe
30
31 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -debug \
32         -nowarn:0162 -nowarn:0168 -nowarn:0219 -nowarn:0414 -nowarn:0618 \
33         -nowarn:0169 -nowarn:1690 -nowarn:0649 -nowarn:0612 -nowarn:3021 \
34         -nowarn:0197
35 ILASM = $(RUNTIME) $(CLASS)/ilasm.exe
36
37 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
38
39 STRESS_TESTS_SRC=       \
40         abort-stress-1.cs       \
41         abort-stress-2.cs       \
42         abort-stress-3.cs       \
43         domain-stress.cs        \
44         gchandle-stress.cs      \
45         monitor-stress.cs       \
46         thread-stress.cs        \
47         gc-stress.cs            \
48         gc-copy-stress.cs       \
49         gc-graystack-stress.cs          \
50         exit-stress.cs          \
51         process-stress.cs       \
52         assembly-load-stress.cs
53
54 # Disabled until ?mcs is fixed
55 #       bug-331958.cs
56 BASE_TEST_CS_SRC=               \
57         bug-2907.cs             \
58         array-init.cs           \
59         arraylist.cs            \
60         assemblyresolve_event.cs        \
61         assemblyresolve_event3.cs       \
62         assemblyresolve_event4.cs       \
63         checked.cs              \
64         char-isnumber.cs        \
65         create-instance.cs      \
66         field-layout.cs         \
67         pack-layout.cs          \
68         pack-bug.cs             \
69         hash-table.cs           \
70         test-ops.cs             \
71         obj.cs                  \
72         test-dup-mp.cs          \
73         string.cs               \
74         stringbuilder.cs        \
75         switch.cs               \
76         outparm.cs              \
77         delegate.cs             \
78         bitconverter.cs         \
79         exception.cs            \
80         exception2.cs           \
81         exception3.cs           \
82         exception4.cs           \
83         exception5.cs           \
84         exception6.cs           \
85         exception7.cs           \
86         exception8.cs           \
87         exception10.cs          \
88         exception11.cs          \
89         exception12.cs          \
90         exception13.cs          \
91         exception14.cs          \
92         exception15.cs          \
93         exception16.cs          \
94         exception17.cs          \
95         exception18.cs          \
96         typeload-unaligned.cs   \
97         struct.cs               \
98         valuetype-gettype.cs    \
99         typeof-ptr.cs           \
100         static-constructor.cs   \
101         pinvoke.cs              \
102         pinvoke2.cs             \
103         pinvoke3.cs             \
104         pinvoke11.cs            \
105         pinvoke13.cs            \
106         pinvoke17.cs            \
107         invoke.cs               \
108         invoke2.cs              \
109         runtime-invoke.cs               \
110         invoke-string-ctors.cs          \
111         reinit.cs               \
112         box.cs                  \
113         array.cs                \
114         enum.cs                 \
115         enum2.cs                \
116         enum-intrins.cs         \
117         property.cs             \
118         enumcast.cs             \
119         assignable-tests.cs     \
120         array-cast.cs           \
121         array-subtype-attr.cs   \
122         cattr-compile.cs        \
123         cattr-field.cs          \
124         cattr-object.cs         \
125         custom-attr.cs          \
126         double-cast.cs          \
127         newobj-valuetype.cs     \
128         arraylist-clone.cs      \
129         setenv.cs               \
130         vtype.cs                \
131         isvaluetype.cs          \
132         iface6.cs               \
133         iface7.cs               \
134         ipaddress.cs            \
135         array-vt.cs             \
136         interface1.cs           \
137         reflection-enum.cs      \
138         reflection-prop.cs      \
139         reflection4.cs          \
140         reflection5.cs          \
141         reflection-const-field.cs \
142         many-locals.cs          \
143         string-compare.cs       \
144         test-prime.cs           \
145         test-tls.cs             \
146         params.cs               \
147         reflection.cs           \
148         interface.cs            \
149         iface.cs                \
150         iface2.cs               \
151         iface3.cs               \
152         iface4.cs               \
153         iface-large.cs          \
154         virtual-method.cs       \
155         intptrcast.cs           \
156         indexer.cs              \
157         stream.cs               \
158         console.cs              \
159         shift.cs                \
160         jit-int.cs              \
161         jit-uint.cs             \
162         jit-long.cs             \
163         long.cs                 \
164         jit-ulong.cs            \
165         jit-float.cs            \
166         pop.cs                  \
167         time.cs                 \
168         appdomain.cs        \
169         appdomain1.cs           \
170         appdomain2.cs           \
171         appdomain-client.cs     \
172         appdomain-unload.cs \
173         appdomain-async-invoke.cs       \
174         loader.cs       \
175         pointer.cs              \
176         hashcode.cs             \
177         delegate1.cs            \
178         delegate2.cs            \
179         delegate3.cs            \
180         delegate5.cs            \
181         delegate6.cs            \
182         delegate7.cs            \
183         delegate8.cs            \
184         delegate9.cs            \
185         delegate10.cs           \
186         delegate11.cs           \
187         delegate12.cs           \
188         remoting1.cs            \
189         remoting2.cs            \
190         remoting3.cs            \
191         remoting4.cs            \
192         remoting5.cs            \
193         largeexp.cs             \
194         largeexp2.cs            \
195         marshalbyref1.cs        \
196         static-ctor.cs          \
197         inctest.cs              \
198         bound.cs                \
199         array-invoke.cs         \
200         test-arr.cs             \
201         decimal.cs              \
202         decimal-array.cs        \
203         marshal.cs              \
204         marshal1.cs             \
205         marshal2.cs             \
206         marshal3.cs             \
207         marshal5.cs             \
208         marshal6.cs             \
209         marshal7.cs             \
210         marshal8.cs             \
211         marshal9.cs             \
212         marshalbool.cs          \
213         marshal-valuetypes.cs   \
214         test-byval-in-struct.cs \
215         thread.cs               \
216         thread5.cs              \
217         thread6.cs              \
218         thread-static.cs        \
219         thread-static-init.cs   \
220         context-static.cs       \
221         float-pop.cs            \
222         interfacecast.cs        \
223         array3.cs               \
224         classinit.cs            \
225         classinit2.cs           \
226         classinit3.cs           \
227         synchronized.cs         \
228         async_read.cs           \
229         threadpool.cs           \
230         threadpool1.cs          \
231         threadpool-exceptions1.cs \
232         threadpool-exceptions2.cs \
233         threadpool-exceptions3.cs \
234         threadpool-exceptions4.cs \
235         threadpool-exceptions5.cs \
236         threadpool-exceptions6.cs \
237         threadpool-exceptions7.cs \
238         base-definition.cs      \
239         bug-27420.cs            \
240         bug-47295.cs            \
241         bug-46781.cs            \
242         bug-48015.cs            \
243         bug-42136.cs            \
244         bug-59286.cs            \
245         bug-70561.cs            \
246         bug-78311.cs            \
247         bug-78653.cs            \
248         bug-78656.cs            \
249         bug-77127.cs            \
250         bug-323114.cs           \
251         bug-Xamarin-5278.cs     \
252         interlocked.cs          \
253         cross-domain.cs         \
254         appdomain-exit.cs       \
255         delegate-async-exit.cs  \
256         delegate-delegate-exit.cs       \
257         delegate-exit.cs        \
258         finalizer-abort.cs      \
259         finalizer-exception.cs  \
260         finalizer-exit.cs       \
261         finalizer-thread.cs     \
262         main-exit.cs    \
263         main-returns-abort-resetabort.cs        \
264         main-returns-background-abort-resetabort.cs     \
265         main-returns-background-resetabort.cs   \
266         main-returns-background.cs      \
267         main-returns-background-change.cs       \
268         main-returns.cs         \
269         subthread-exit.cs       \
270         desweak.cs              \
271         cominterop.cs           \
272         exists.cs               \
273         handleref.cs    \
274         transparentproxy.cs \
275         dbnull-missing.cs       \
276         test-type-ctor.cs       \
277         soft-float-tests.cs     \
278         thread-exit.cs          \
279         finalize-parent.cs      \
280         assemblyresolve_event2.2.cs     \
281         interlocked-2.2.cs      \
282         pinvoke-2.2.cs          \
283         bug-78431.2.cs          \
284         bug-79684.2.cs          \
285         catch-generics.2.cs     \
286         event-get.2.cs          \
287         safehandle.2.cs         \
288         stackframes-async.2.cs          \
289         module-cctor-loader.2.cs        \
290         generics-invoke-byref.2.cs      \
291         generic-signature-compare.2.cs  \
292         generics-sharing.2.cs   \
293         shared-generic-methods.2.cs     \
294         shared-generic-synchronized.2.cs        \
295         generic-inlining.2.cs   \
296         generic-initobj.2.cs    \
297         generic-delegate.2.cs   \
298         generic-sizeof.2.cs     \
299         generic-virtual.2.cs    \
300         generic-interface-methods.2.cs  \
301         generic-array-type.2.cs \
302         generic-method-patching.2.cs    \
303         generic-static-methods.2.cs     \
304         generic-null-call.2.cs  \
305         generic-special.2.cs    \
306         generic-exceptions.2.cs \
307         generic-virtual2.2.cs   \
308         generic-valuetype-interface.2.cs        \
309         generic-getgenericarguments.2.cs        \
310         generic-type-builder.2.cs       \
311         generic-synchronized.2.cs       \
312         generic-delegate-ctor.2.cs      \
313         generic-array-iface-set.2.cs    \
314         generic-typedef.2.cs    \
315         generic-marshalbyref.2.cs       \
316         generic-xdomain.2.cs    \
317         dynamic-generic-size.cs \
318         bug-431413.2.cs \
319         bug-459285.2.cs \
320         generic-virtual-invoke.2.cs     \
321         bug-461198.2.cs \
322         generic-sealed-virtual.2.cs     \
323         generic-system-arrays.2.cs      \
324         generic-stack-traces.2.cs       \
325         generic-stack-traces2.2.cs      \
326         bug-472600.2.cs \
327         recursive-generics.2.cs \
328         bug-473482.2.cs \
329         bug-473999.2.cs \
330         bug-479763.2.cs \
331         bug-616463.cs   \
332         bug-80392.2.cs          \
333         dynamic-method-access.2.cs      \
334         dynamic-method-finalize.2.cs    \
335         dynamic-method-stack-traces.cs  \
336         bug-82194.2.cs  \
337         anonarray.2.cs  \
338         ienumerator-interfaces.2.cs     \
339         array-enumerator-ifaces.2.cs    \
340         generic_type_definition_encoding.2.cs \
341         generic_type_definition.2.cs    \
342         bug-333798.2.cs         \
343         bug-333798-tb.2.cs              \
344         bug-335131.2.cs         \
345         bug-322722_patch_bx.2.cs                \
346         bug-348522.2.cs         \
347         bug-340662_bug.cs       \
348         bug-322722_dyn_method_throw.2.cs        \
349         bug-389886-2.cs \
350         bug-325283.2.cs \
351         thunks.cs \
352         winx64structs.cs \
353         bug-349190.2.cs \
354         nullable_boxing.2.cs    \
355         valuetype-equals.cs     \
356         custom-modifiers.2.cs   \
357         bug-382986.cs   \
358         test-inline-call-stack.cs       \
359         bug-324535.cs   \
360         modules.cs      \
361         bug-81673.cs    \
362         bug-81691.cs    \
363         bug-80307.cs    \
364         bug-415577.cs   \
365         filter-stack.cs \
366         vararg2.cs      \
367         bug-389886-sre-generic-interface-instances.cs   \
368         bug-461867.cs   \
369         bug-461941.cs   \
370         bug-461261.cs   \
371         bug-400716.cs   \
372         bug-462592.cs   \
373         bug-459094.cs   \
374         generic-unloading.2.cs  \
375         generic-unloading-sub.2.cs      \
376         bug-467456.cs   \
377         appdomain-unload-callback.cs    \
378         bug-508538.cs   \
379         bug-472692.2.cs         \
380         gchandles.cs    \
381         interlocked-3.cs        \
382         interlocked-4.2.cs      \
383         appdomain-thread-abort.cs \
384         xdomain-threads.cs      \
385         w32message.cs   \
386         bug-544446.cs   \
387         gc-altstack.cs  \
388         large-gc-bitmap.cs      \
389         bug-561239.cs   \
390         bug-562150.cs   \
391         bug-575941.cs   \
392         bug-599469.cs   \
393         bug-389886-3.cs \
394         monitor.cs      \
395         monitor-resurrection.cs \
396         dynamic-method-resurrection.cs  \
397         bug-666008.cs   \
398         bug-685908.cs   \
399         sgen-long-vtype.cs      \
400         delegate-invoke.cs      \
401         bug-696593.cs   \
402         bug-705140.cs   \
403         bug-1147.cs     \
404         mono-path.cs    \
405         bug-bxc-795.cs  \
406         bug-3903.cs     \
407         async-with-cb-throws.cs \
408         appdomain-unload-doesnot-raise-pending-events.cs        \
409         bug-6148.cs     \
410         assembly_append_ordering.cs     \
411         bug-10127.cs    \
412         bug-18026.cs    \
413         allow-synchronous-major.cs      \
414         unload-appdomain-on-shutdown.cs \
415         block_guard_restore_aligment_on_exit.cs \
416         thread_static_gc_layout.cs \
417         sleep.cs \
418         bug-27147.cs    \
419         bug-30085.cs    \
420         bug-17537.cs    \
421         pinvoke_ppcc.cs \
422         pinvoke_ppcs.cs \
423         pinvoke_ppci.cs \
424         pinvoke_ppcf.cs \
425         pinvoke_ppcd.cs
426
427 TEST_CS_SRC_DIST=       \
428         $(BASE_TEST_CS_SRC)     \
429         async-exc-compilation.cs \
430         filter-stack.cs \
431         finally_guard.cs \
432         finally_block_ending_in_dead_bb.cs
433
434 TEST_CS_SRC_GEN = \
435         runtime-invoke.gen.cs \
436         imt_big_iface_test.cs
437
438 if AMD64
439 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs finally_block_ending_in_dead_bb.cs
440 # #651684
441 PLATFORM_DISABLED_TESTS = finally_guard.exe
442 else
443 if X86
444 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs finally_block_ending_in_dead_bb.cs
445 else
446 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
447 endif
448 endif
449
450 if IA64
451 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
452 # bug #319249
453 PLATFORM_DISABLED_TESTS=exception17.exe
454 PLATFORM_DISABLED_TESTS+=winx64structs.exe
455 endif
456
457 if X86
458
459 if HOST_WIN32
460 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe finally_block_ending_in_dead_bb.exe \
461         bug-18026.exe monitor.exe threadpool-exceptions5.exe
462 endif
463
464 endif
465
466 if POWERPC
467 # bug #71274
468 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
469 endif
470
471 if POWERPC64
472 # FIXME: These tests hang/fail for unknown reasons
473 PLATFORM_DISABLED_TESTS=monitor.exe threadpool-exceptions5.exe
474 endif
475
476 if ARM
477 PLATFORM_DISABLED_TESTS=filter-stack.exe
478 endif
479
480 if MIPS
481 # monitor.exe is racy
482 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
483 endif
484
485 if S390X
486 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
487 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
488 endif
489
490 if NACL_CODEGEN
491 # Tests that use Thread.Abort()
492 PLATFORM_DISABLED_TESTS= abort-stress-1.exe \
493                          abort-stress-2.exe \
494                          abort-stress-3.exe \
495                          appdomain-thread-abort.exe \
496                          async-exc-compilation.exe \
497                          bug-561239.exe \
498                          bug-70561.exe \
499                          finalizer-abort.exe \
500                          finally_guard.exe \
501                          finally_block_ending_in_dead_bb.exe \
502                          main-returns-abort-resetabort.exe \
503                          main-returns-background-abort-resetabort.exe \
504                          thread6.exe \
505                          threadpool-exceptions5.exe \
506                          threadpool-exceptions6.exe
507
508 # Tests that rely on AppDomain.Unload
509 PLATFORM_DISABLED_TESTS+= appdomain-async-invoke.exe \
510                           appdomain-exit.exe \
511                           appdomain-unload-callback.exe \
512                           appdomain-unload.exe \
513                           domain-stress.exe \
514                           generic-unloading.2.exe \
515                           monitor.exe \
516                           remoting4.exe \
517                           threadpool-exceptions7.exe \
518                           xdomain-threads.exe
519
520 # pinvoke2 attaches a thread to the runtime, but
521 # doesn't 'unattach' it and it hangs in GC on exit
522 PLATFORM_DISABLED_TESTS+= pinvoke2.exe
523
524 # Tests that currently hang waiting for non-main threads
525 # to exit in NaCl, need to investigate.  Most are AppDomain
526 # creation and Delegate tests.
527 PLATFORM_DISABLED_TESTS+= appdomain1.exe \
528                           delegate9.exe \
529                           marshal-valuetypes.exe \
530                           cross-domain.exe \
531                           stackframes-async.2.exe \
532                           generic-marshalbyref.2.exe \
533                           generic-xdomain.2.exe \
534                           bug-415577.exe
535
536 # Tests that fail trying to write files (appdomain create mostly)
537 PLATFORM_DISABLED_TESTS+= bug-335131.2.exe \
538                           bug-349190.2.exe \
539                           bug-80307.exe \
540                           bug-462592.exe
541
542 # FIXME: don't know why delegate2.exe fails, it shouldn't
543 PLATFORM_DISABLED_TESTS+= delegate2.exe
544
545 # These tests newly fail with the latest revision. pinvoke3 fails because
546 # of a thread attach, the others have not been investigated.  TODO revisit.
547 PLATFORM_DISABLED_TESTS+= pinvoke3.exe \
548                           async_read.exe \
549                           async-with-cb-throws.exe \
550                           appdomain-unload-doesnot-raise-pending-events.exe \
551                           gsharing-valuetype-layout.exe
552
553 if X86
554 # FIXME: There are problems with async callbacks and results on NaCl 32-bit
555 PLATFORM_DISABLED_TESTS+= delegate1.exe \
556                           delegate3.exe \
557                           delegate5.exe \
558                           delegate8.exe \
559                           threadpool.exe \
560                           threadpool1.exe \
561                           threadpool-exceptions3.exe \
562                           bug-323114.exe \
563                           delegate-exit.exe \
564                           bug-80392.2.exe
565
566 # FIXME: These tests hang/fail for unknown reasons, deal with exiting
567 PLATFORM_DISABLED_TESTS+= main-returns-background-resetabort.exe \
568                           main-returns-background.exe \
569                           main-returns-background-change.exe
570 endif
571
572 endif
573
574 # The two finalizer tests only work under sgen
575 # gc-altstack.exe fails under boehm because it has no support for altstack
576 # bug-459094.exe creates an extremely deep directory tree
577 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
578 # reverted.
579 # bug-Xamarin-5278.exe got broken by 5d26590e79da139a284459299aee95c25f4cd835
580 DISABLED_TESTS=                 \
581         delegate-async-exception.exe    \
582         bug-348522.2.exe        \
583         bug-459094.exe \
584         delegate-invoke.exe \
585         bug-Xamarin-5278.exe \
586         $(PLATFORM_DISABLED_TESTS) \
587         $(EXTRA_DISABLED_TESTS)
588
589 DISABLED_TESTS_WRENCH=  \
590         $(DISABLED_TESTS)       \
591         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
592         main-returns-background-resetabort.exe \
593         main-returns-background-abort-resetabort.exe    \
594         thread6.exe     \
595         assemblyresolve_event3.exe \
596         delegate2.exe   \
597         finally_guard.exe \
598         gc-altstack.exe \
599         generic-xdomain.2.exe
600
601 AOT_DISABLED_TESTS=constraints-load.exe
602
603 # These only compile with MS CSC
604 TEST_CSC_SRC=                   \
605         vararg.cs
606
607 TEST_IL_SRC=                    \
608         field-access.il         \
609         method-access.il        \
610         ldftn-access.il         \
611         cpblkTest.il            \
612         vbinterface.il          \
613         calliTest.il            \
614         ckfiniteTest.il         \
615         fault-handler.il                \
616         locallocTest.il         \
617         initblkTest.il          \
618         qt-instance.il          \
619         vararg.il               \
620         bug-29859.il            \
621         bug-78549.il            \
622         static-fields-nonconst.il       \
623         reload-at-bb-end.il     \
624         test-enum-indstoreil.il \
625         filter-bug.il           \
626         even-odd.il             \
627         bug-82022.il    \
628         vt-sync-method.il       \
629         enum_types.il   \
630         invalid-token.il        \
631         call_missing_method.il  \
632         call_missing_class.il   \
633         ldfld_missing_field.il  \
634         ldfld_missing_class.il  \
635         find-method.2.il        \
636         bug-79215.2.il  \
637         bug-79956.2.il  \
638         bug-327438.2.il \
639         bug-387274.2.il \
640         bug-426309.2.il \
641         ldtoken_with_byref_typespec.2.il \
642         resolve_method_bug.2.il \
643         resolve_field_bug.2.il \
644         resolve_type_bug.2.il   \
645         generics-sharing-other-exc.2.il \
646         generic-ldobj.2.il      \
647         generic-mkrefany.2.il   \
648         generic-refanyval.2.il  \
649         generic-ldtoken.2.il    \
650         generic-ldtoken-method.2.il     \
651         generic-ldtoken-field.2.il      \
652         generic-tailcall.2.il   \
653         generic-tailcall2.2.il  \
654         generic-array-exc.2.il  \
655         generic-valuetype-newobj2.2.il  \
656         generic-valuetype-newobj.2.il   \
657         generic-constrained.2.il        \
658         generic-type-load-exception.2.il        \
659         bug-81466.il    \
660         bug457574.il    \
661         bug445361.il    \
662         bug-463303.il   \
663         bug469742.2.il  \
664         bug-528055.il   \
665         constraints-load.il     \
666         array_load_exception.il \
667         bug-481403.il   \
668         interface-with-static-method.il \
669         bug-515884.il   \
670         bug-633291.il   \
671         delegate-with-null-target.il    \
672         bug-318677.il   \
673         gsharing-valuetype-layout.il    \
674         invalid_generic_instantiation.il
675
676
677 # pre-requisite test sources: files that are not test themselves
678 # but that need to be compiled
679 PREREQ_IL_SRC=event-il.il module-cctor.il
680 PREREQ_CS_SRC=
681 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
682 PREREQ_CS_DLL_SRC=
683
684 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
685 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
686 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
687 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
688 TESTBS=$(BENCHSRC:.cs=.exe)
689 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
690
691 EXTRA_DIST=test-driver test-runner.cs $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
692         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
693
694 %.exe: %.il
695         $(ILASM) -out:$@ $<
696
697 %.exe: %.cs TestDriver.dll
698         $(MCS) -r:TestDriver.dll -out:$@ $<
699
700 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
701 if POWERPC
702 test_platform:
703 else
704 # Can't use mkbundle on win32 since there is no static build there
705 # Can't run test-unhandled-exception on Windows because of all the debug popups...
706 if HOST_WIN32
707 test_platform:
708 else
709 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
710 #test_platform: testbundle test-iomap-regression
711 test_platform:  test-iomap-regression
712 endif
713 endif
714
715 if X86
716 if HOST_WIN32
717 else
718 test_platform: test-eglib-remap
719 endif
720 endif
721
722 # Target to precompile the test executables
723 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
724
725 #
726 # Test that no symbols are missed in eglib-remap.h
727 #
728 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file\|g_Ctoc\'
729 if NACL_CODEGEN
730 test-eglib-remap:
731 else
732 test-eglib-remap:
733         @echo "Testing eglib remap..."
734         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
735 endif
736
737 #
738 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
739 # code that checks that the table is properly sorted
740 #
741 if NACL_CODEGEN
742 test-messages:
743 else
744 if HOST_WIN32
745 test-messages:
746 else
747 test-messages: w32message.exe
748         > test_messages.zero
749         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe > w32message.allout 2>&1 && cmp test_messages.zero w32message.allout
750 endif
751 endif
752
753 if AMD64
754 test-sgen : sgen-tests
755 else
756 if X86
757 if HOST_WIN32
758 test-sgen :
759 else
760 test-sgen : sgen-tests
761 endif
762 else
763 if ARM
764 test-sgen : sgen-tests
765 else
766 if S390X
767 test-sgen : sgen-regular-tests
768 endif
769 endif
770 endif
771 endif
772
773 # Precompile the test assemblies in parallel
774 compile-tests:
775         $(MAKE) -j4 $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
776
777 # Remove empty .stdout and .stderr files for wrench
778 rm-empty-logs:
779         @echo "Removing empty logs..."
780         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
781
782 assemblyresolve/test/asm.dll:
783         $(MAKE) -C assemblyresolve prereq
784
785 TestDriver.dll:
786         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
787
788 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
789         @failed=0; \
790         passed=0; \
791         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
792         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
793         for i in $(TESTSI_CS); do       \
794                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
795                 then \
796                         passed=`expr $${passed} + 1`; \
797                 else \
798                         if [ $$? = 2 ]; then break; fi; \
799                         failed=`expr $${failed} + 1`; \
800                 fi \
801         done; \
802         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
803
804 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
805         @failed=0; \
806         passed=0; \
807         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
808         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
809         for i in $(TESTSI_IL); do       \
810                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
811                 then \
812                         passed=`expr $${passed} + 1`; \
813                 else \
814                         if [ $$? = 2 ]; then break; fi; \
815                         failed=`expr $${failed} + 1`; \
816                 fi \
817         done; \
818         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
819
820 testb: $(TEST_PROG) $(TESTBS)
821         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
822         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
823         for i in $(TESTBS); do  \
824                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS);  \
825         done
826
827 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
828         @failed=0; \
829         passed=0; \
830         failed_tests="";\
831         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
832         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
833         rm -f testlist testlist.sorted; \
834         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do echo $${i} >> testlist; sort testlist > testlist.sorted; done; \
835         for i in `cat testlist.sorted`; do \
836                 rm -f $${i}.so; \
837                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
838                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
839                 then \
840                         passed=`expr $${passed} + 1`; \
841                 else \
842                         if [ $$? = 2 ]; then break; fi; \
843                         failed=`expr $${failed} + 1`; \
844                         failed_tests="$${failed_tests} $$i"; \
845                 fi \
846         done; \
847         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
848         rm -f testlist testlist.sorted; \
849         if [ $${failed} != 0 ]; then \
850           echo -e "\nFailed tests:\n"; \
851           for i in $${failed_tests}; do \
852             echo $${i}; \
853             if [ "x$$V" = "x1" ]; then \
854               cat $${i}.stdout; \
855               cat $${i}.stderr; \
856             fi; \
857           done; \
858           exit 1; \
859         fi
860
861 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
862         @if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
863         $(RUNTIME) ./test-runner.exe -j a --disabled "$${disabled_tests}" $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
864
865 runtest-managed-serial: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
866         @if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
867         $(RUNTIME) ./test-runner.exe -j 1 --disabled "$${disabled_tests}" $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
868
869 testjit:
870         @if test x$(M) != x0; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
871
872 testaot:
873         @$(MAKE) AOT=1 runtest
874
875 testtrace:
876         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
877
878 testinterp:
879         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
880
881 testjitspeed: $(JITTEST_PROG) $(TESTBS)
882         for i in $(TESTBS); do  \
883                 echo $$i;       \
884                 time $(JITTEST_PROG) $$i;       \
885         done
886
887 test-iomap-regression: exists.cs
888         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
889         @echo "Testing exists.exe..."
890         @MONO_IOMAP=all $(RUNTIME) exists.exe
891
892 stresstest: $(STRESS_TESTS)
893         @failed=0; \
894         passed=0; \
895         failed_tests="";\
896         for i in $(STRESS_TESTS); do    \
897                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
898                 then \
899                         passed=`expr $${passed} + 1`; \
900                 else \
901                         if [ $$? = 2 ]; then break; fi; \
902                         failed=`expr $${failed} + 1`; \
903                         failed_tests="$${failed_tests} $$i"; \
904                 fi \
905         done; \
906         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
907         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
908           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
909
910 testbundle: console.exe
911         @echo "Testing mkbundle..."
912         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
913         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) ./a.out >> mkbundle.stdout
914         @- rm -rf a.out
915
916 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
917 test-type-load: TestDriver.dll
918         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
919         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
920         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
921         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
922         @echo "Testing load-exception.exe..."
923         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
924
925 EXTRA_DIST += custom-attr-errors.cs custom-attr-errors-lib.cs
926 test-cattr-type-load: TestDriver.dll custom-attr-errors.cs custom-attr-errors-lib.cs
927         $(MCS) -D:WITH_MEMBERS /t:library $(srcdir)/custom-attr-errors-lib.cs
928         $(MCS) -r:TestDriver.dll -r:custom-attr-errors-lib.dll  $(srcdir)/custom-attr-errors.cs
929         $(MCS) /t:library $(srcdir)/custom-attr-errors-lib.cs
930         @echo "Testing custom-attribute-load-exceptions.exe..."
931         @$(RUNTIME) custom-attr-errors.exe > custom-attr-errors.exe.stdout 2> custom-attr-errors.exe.stderr
932
933 EXTRA_DIST += reflection-load-with-context-lib.cs reflection-load-with-context-second-lib.cs reflection-load-with-context.cs
934 test-reflection-load-with-context: reflection-load-with-context-lib.cs reflection-load-with-context-second-lib.cs reflection-load-with-context.exe
935         rm -rf reflection-load-dir
936         mkdir reflection-load-dir
937         $(MCS) /t:library $(srcdir)/reflection-load-with-context-second-lib.cs -out:reflection-load-dir/reflection-load-with-context-second-lib.dll
938         $(MCS) /t:library -r:reflection-load-dir/reflection-load-with-context-second-lib.dll $(srcdir)/reflection-load-with-context-lib.cs -out:reflection-load-dir/reflection-load-with-context-lib.dll
939         @echo "Testing reflection-load-with-context.cs.exe..."
940         @$(RUNTIME) reflection-load-with-context.exe > reflection-load-with-context.exe.stdout 2> reflection-load-with-context.exe.stderr
941
942
943 EXTRA_DIST += debug-casts.cs
944 # This depends on TLS, so its not ran by default
945 debug-casts:
946         @$(MCS) -r:TestDriver.dll $(srcdir)/debug-casts.cs
947         @$(RUNTIME) --debug=casts debug-casts.exe
948
949 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs sgen-domain-unload-2.cs sgen-suspend.cs sgen-new-threads-dont-join-stw.cs sgen-bridge-xref.cs bug-17590.cs sgen-toggleref.cs
950
951
952 #those are actually configurations, eg plain_sgen-descriptors.exe
953 #DISABLE_SGEN_TESTS =
954
955 SGEN_TESTS =    \
956         finalizer-wait.exe      \
957         critical-finalizers.exe \
958         sgen-descriptors.exe    \
959         sgen-gshared-vtype.exe  \
960         sgen-domain-unload.exe  \
961         sgen-domain-unload-2.exe        \
962         sgen-weakref-stress.exe \
963         sgen-cementing-stress.exe       \
964         sgen-case-23400.exe     \
965         sgen-new-threads-dont-join-stw.exe      \
966         gc-graystack-stress.exe \
967         bug-17590.exe
968
969 SGEN_CONFIGURATIONS =   \
970         "|plain"        \
971         "major=marksweep-conc|ms-conc"  \
972         "major=marksweep-conc,minor=split|ms-conc-split"        \
973         "minor=split|ms-split"  \
974         "minor=split,alloc-ratio=95|ms-split-95"        \
975         "|plain-clear-at-gc|clear-at-gc"        \
976         "major=marksweep-conc|ms-conc-clear-at-gc|clear-at-gc"  \
977         "minor=split|ms-split-clear-at-gc|clear-at-gc"
978
979
980 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
981 SGEN_BRIDGE_CONFIGURATIONS =    \
982         "|plain"        \
983         ",major=marksweep-conc|ms-conc" \
984         "minor=split|ms-split"  \
985         "bridge-implementation=new|plain-new-bridge"    \
986         "bridge-implementation=new,major=marksweep-conc|ms-conc-new-bridge"     \
987         "bridge-implementation=new,minor=split|ms-split-new-bridge"     \
988         "bridge-implementation=tarjan|plain-tarjan-bridge"      \
989         "bridge-implementation=tarjan,minor=split|ms-split-tarjan-bridge"
990
991 sgen-regular-tests: $(SGEN_TESTS)
992         @failed=0; \
993         passed=0; \
994         failed_tests="";\
995         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
996         for test in $+; do      \
997                 echo "...$$test";       \
998                 for conf in $(SGEN_CONFIGURATIONS); do  \
999                         name=`echo $$conf | cut -d\| -f 2`;     \
1000                         params=`echo $$conf | cut -d\| -f 1`;   \
1001                         debug_opt=`echo $$conf | cut -d\| -f 3`;        \
1002                         test_name="$${test}|$${name}";  \
1003                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" MONO_GC_DEBUG="$$debug_opt" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);     \
1004                         then \
1005                                 passed=`expr $${passed} + 1`; \
1006                         else \
1007                                 if [ $$? = 2 ]; then break; fi; \
1008                                 failed=`expr $${failed} + 1`; \
1009                                 failed_tests="$${failed_tests} $$test_name"; \
1010                         fi \
1011                 done    \
1012         done;   \
1013         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1014         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1015           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1016
1017 sgen-bridge-tests1: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
1018         @failed=0; \
1019         passed=0; \
1020         failed_tests="";\
1021         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1022         for test in $+; do      \
1023                 echo "...$$test";       \
1024                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
1025                         name=`echo $$conf | cut -d\| -f 2`;     \
1026                         params=`echo $$conf | cut -d\| -f 1`;   \
1027                         test_name="$${test}|$${name}";  \
1028                         if MONO_GC_DEBUG="bridge=Bridge" MONO_GC_PARAMS="$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS); \
1029                         then \
1030                                 passed=`expr $${passed} + 1`; \
1031                         else \
1032                                 if [ $$? = 2 ]; then break; fi; \
1033                                 failed=`expr $${failed} + 1`; \
1034                                 failed_tests="$${failed_tests} $$test_name"; \
1035                         fi \
1036                 done    \
1037         done;   \
1038         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1039         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1040           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1041
1042 sgen-bridge-tests2: sgen-bridge-xref.exe
1043         @failed=0; \
1044         passed=0; \
1045         failed_tests="";\
1046         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1047         for test in $+; do      \
1048                 echo "...$$test";       \
1049                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
1050                         name=`echo $$conf | cut -d\| -f 2`;     \
1051                         params=`echo $$conf | cut -d\| -f 1`;   \
1052                         test_name="$${test}|$${name}";  \
1053                         if MONO_GC_DEBUG="bridge=2Bridge" MONO_GC_PARAMS="$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);        \
1054                         then \
1055                                 passed=`expr $${passed} + 1`; \
1056                         else \
1057                                 if [ $$? = 2 ]; then break; fi; \
1058                                 failed=`expr $${failed} + 1`; \
1059                                 failed_tests="$${failed_tests} $$test_name"; \
1060                         fi \
1061                 done    \
1062         done;   \
1063         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1064         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1065           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1066
1067 sgen-toggleref-tests: sgen-toggleref.exe
1068         @failed=0; \
1069         passed=0; \
1070         failed_tests="";\
1071         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1072         for test in $+; do      \
1073                 echo "...$$test";       \
1074                 for conf in $(SGEN_CONFIGURATIONS); do  \
1075                         name=`echo $$conf | cut -d\| -f 2`;     \
1076                         params=`echo $$conf | cut -d\| -f 1`;   \
1077                         test_name="$${test}|$${name}";  \
1078                         if MONO_GC_PARAMS="toggleref-test,$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);  \
1079                         then \
1080                                 passed=`expr $${passed} + 1`; \
1081                         else \
1082                                 if [ $$? = 2 ]; then break; fi; \
1083                                 failed=`expr $${failed} + 1`; \
1084                                 failed_tests="$${failed_tests} $$test_name"; \
1085                         fi \
1086                 done    \
1087         done;   \
1088         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1089         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1090           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1091
1092 sgen-bridge-tests: sgen-bridge-tests1 sgen-bridge-tests2
1093
1094 sgen-tests: sgen-regular-tests sgen-bridge-tests sgen-toggleref-tests
1095
1096 AOT_CONFIGURATIONS=     \
1097         "|regular"      \
1098         "--gc=boehm|boehm"
1099
1100 #LLVM crashes, got to fix it first.
1101 #       "--llvm|llvm"   \
1102 #       "--llvm --gc=boehm|llvm+boehm"
1103
1104
1105 test-aot:
1106         @failed=0; \
1107         passed=0; \
1108         failed_tests="";\
1109         profile=$(DEFAULT_PROFILE);     \
1110         tmpfile=`mktemp -t mono_aot_output` || exit 1;  \
1111         rm -f test-aot-$${name}.stdout test-aot-$${name}.stderr; \
1112         for assembly in $(mcs_topdir)/class/lib/$$profile/*.dll ; do    \
1113                 asm_name=`basename $$assembly`; \
1114                 echo "... $$asm_name";  \
1115                 for conf in $(AOT_CONFIGURATIONS); do   \
1116                         name=`echo $$conf | cut -d\| -f 2`;     \
1117                         params=`echo $$conf | cut -d\| -f 1`;   \
1118                         test_name="$${asm_name}|$${name}";      \
1119                         echo "  $$test_name";   \
1120                         if MONO_PATH=$(mcs_topdir)/class/lib/$$profile $(JITTEST_PROG_RUN) $$params --aot=outfile=$$tmpfile $$assembly >> test-aot-$${name}.stdout 2>> test-aot-$${name}.stderr;        \
1121                         then \
1122                                 passed=`expr $${passed} + 1`; \
1123                         else \
1124                                 failed=`expr $${failed} + 1`; \
1125                                 failed_tests="$${failed_tests} $$test_name"; \
1126                         fi \
1127                 done;   \
1128         done;   \
1129         rm      $$tmpfile;      \
1130         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1131         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1132         for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1133
1134
1135 # Generated tests for runtime invoke
1136 EXTRA_DIST += gen-runtime-invoke.cs
1137 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
1138         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
1139         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
1140
1141 EXTRA_DIST += make-imt-test.cs
1142 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
1143         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
1144         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
1145
1146 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
1147 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
1148         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
1149 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
1150         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
1151
1152 EXTRA_DIST += unhandled-exception-base-configuration.config
1153 EXTRA_DIST += unhandled-exception-legacy-configuration.config
1154 EXTRA_DIST += appdomain-unload.exe.config
1155 EXTRA_DIST += unhandled-exception-test-case.2.cs
1156 EXTRA_DIST += unhandled-exception-test-runner.2.cs
1157 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
1158         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
1159 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
1160         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
1161 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
1162         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
1163 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
1164         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
1165         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
1166         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
1167         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
1168 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
1169         $(MCS) /debug unhandled-exception-test-case.1.cs
1170 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
1171         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
1172 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
1173         $(MCS) /debug unhandled-exception-test-case.2.cs
1174 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
1175         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
1176 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
1177         $(MCS) /debug unhandled-exception-test-runner.2.cs
1178
1179 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
1180         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
1181
1182 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
1183 bug-80307.exe: $(srcdir)/bug-80307.cs
1184         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
1185         cd $(top_builddir)/runtime && $(MAKE) test-support-files
1186
1187 EXTRA_DIST += bug-81673-interface.cs
1188 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
1189         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1190         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
1191         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1192
1193 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
1194 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
1195         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
1196         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
1197         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
1198         rm -f bug-81691-a.dll
1199 bug-81691.exe: bug-81691-b.dll
1200
1201 EXTRA_DIST += bug-81466-lib.il
1202 bug-81466-lib.dll: bug-81466-lib.il
1203         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
1204 bug-81466.exe: bug-81466.il bug-81466-lib.dll
1205         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
1206
1207 EXTRA_DIST += bug-324535-il.il
1208 bug-324535-il.dll : bug-324535-il.il
1209         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
1210 bug-324535.exe : bug-324535.cs bug-324535-il.dll
1211         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
1212
1213 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
1214 custom-modifiers-lib.dll: custom-modifiers-lib.il
1215         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
1216 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
1217         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
1218
1219 EXTRA_DIST += bug-382986-lib.cs
1220 bug-382986-lib.dll: bug-382986-lib.cs
1221         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
1222 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
1223         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
1224
1225 EXTRA_DIST += bug-17537-helper.cs
1226 bug-17537-helper.exe: bug-17537-helper.cs
1227         $(MCS) -out:$@ $(srcdir)/bug-17537-helper.cs
1228         chmod -x $@
1229
1230 bug-17537.exe: bug-17537.cs bug-17537-helper.exe
1231         $(MCS) -out:$@ $(srcdir)/bug-17537.cs
1232
1233 EXTRA_DIST += coreclr-security.cs
1234
1235 coreclr-security.exe : coreclr-security.cs
1236         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
1237
1238 test-coreclr-security : coreclr-security.exe
1239         @echo "Testing coreclr-security.exe..."
1240         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
1241
1242 EXTRA_DIST += generic-unboxing.2.il
1243 generic-unboxing.2.dll : generic-unboxing.2.il
1244         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
1245
1246 EXTRA_DIST += generic-boxing.2.il
1247 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
1248         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
1249
1250 EXTRA_DIST += generic-unbox.2.cs
1251 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
1252         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
1253
1254 EXTRA_DIST += generic-box.2.cs
1255 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
1256         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
1257
1258 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
1259 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
1260         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
1261 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
1262         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
1263
1264 bug-3903.exe: bug-3903.cs
1265         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1266
1267 gshared: test-generic-sharing
1268
1269 gshared-aot:
1270         @$(MAKE) AOT=1 gshared
1271
1272 GSHARED_TESTS = \
1273                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1274                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1275                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1276                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1277                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1278                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1279                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1280                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1281                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1282                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1283                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1284                 generic-array-exc.2.exe generic-special.2.exe                   \
1285                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1286                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1287                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1288                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1289                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1290                 generic-constrained.2.exe bug-431413.2.exe                      \
1291                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1292                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1293                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1294                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1295                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1296                 bug-479763.2.exe                                \
1297                 generic-type-load-exception.2.exe bug-616463.exe        \
1298                 bug-1147.exe
1299
1300 test-generic-sharing-normal: $(GSHARED_TESTS)
1301         @for fn in $+ ; do      \
1302                 echo "Testing $$fn ...";        \
1303                 $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;      \
1304                 $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;      \
1305                 $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;      \
1306                 $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;       \
1307                 if [ x$(AOT) = x1 ]; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1308         done
1309
1310 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1311         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1312
1313 if NACL_CODEGEN
1314 test-generic-sharing:
1315 else
1316 test-generic-sharing:
1317         @if test x$(M) != x0; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1318 endif
1319
1320 EXTRA_DIST += async-exceptions.cs
1321 async-exceptions.exe : async-exceptions.cs
1322         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1323 test-async-exceptions : async-exceptions.exe
1324         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1325         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1326
1327 EXTRA_DIST += modules.cs modules-m1.cs
1328 modules-m1.netmodule: modules-m1.cs
1329         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1330 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1331         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1332
1333 # Useful if mono is compiled with --enable-shared=no
1334 patch-libtool:
1335         cp "../../libtool" .
1336         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1337         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1338         touch libtest.c
1339
1340
1341 if NACL_CODEGEN
1342 test-process-exit:
1343 else
1344 EXTRA_DIST += threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1345 test-process-exit:
1346         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1347         @echo "Testing threadpool-in-processexit.exe..."
1348         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1349         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1350 endif
1351
1352 OOM_TESTS =     \
1353         gc-oom-handling.exe     \
1354         gc-oom-handling2.exe
1355
1356
1357 test-oom: $(OOM_TESTS)
1358         @for fn in $+ ; do      \
1359                 echo "Testing $$fn ...";        \
1360                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1361                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1362         done
1363
1364 if HOST_WIN32
1365 test-unhandled-exception-2:
1366 else
1367 test-unhandled-exception-2: unhandled-exception.exe
1368         @echo "Testing unhandled-exception_1 ..."; $(RUNTIME) $+ 1 1> unhandled-exception_1.exe.stdout 2> unhandled-exception_1.exe.stderr; if test "x$$?" != "x1";   then exit 1; fi;  \
1369          echo "Testing unhandled-exception_2 ..."; $(RUNTIME) $+ 2 1> unhandled-exception_2.exe.stdout 2> unhandled-exception_2.exe.stderr; if test "x$$?" != "x0";   then exit 2; fi;  \
1370          echo "Testing unhandled-exception_3 ..."; $(RUNTIME) $+ 3 1> unhandled-exception_3.exe.stdout 2> unhandled-exception_3.exe.stderr; if test "x$$?" != "x0";   then exit 3; fi;  \
1371          echo "Testing unhandled-exception_4 ..."; $(RUNTIME) $+ 4 1> unhandled-exception_4.exe.stdout 2> unhandled-exception_4.exe.stderr; if test "x$$?" != "x0";   then exit 4; fi;  \
1372          echo "Testing unhandled-exception_5 ..."; $(RUNTIME) $+ 5 1> unhandled-exception_5.exe.stdout 2> unhandled-exception_5.exe.stderr; if test "x$$?" != "x255"; then exit 5; fi;  \
1373          echo "Testing unhandled-exception_6 ..."; $(RUNTIME) $+ 6 1> unhandled-exception_6.exe.stdout 2> unhandled-exception_6.exe.stderr; if test "x$$?" != "x0";   then exit 6; fi;  \
1374          echo "Testing unhandled-exception_7 ..."; $(RUNTIME) $+ 7 1> unhandled-exception_7.exe.stdout 2> unhandled-exception_7.exe.stderr; if test "x$$?" != "x0";   then exit 7; fi;  \
1375          echo "Testing unhandled-exception_8 ..."; $(RUNTIME) $+ 8 1> unhandled-exception_8.exe.stdout 2> unhandled-exception_8.exe.stderr; if test "x$$?" != "x3";   then exit 8; fi
1376 endif
1377
1378 noinst_LTLIBRARIES = libtest.la
1379
1380 AM_CPPFLAGS = $(GLIB_CFLAGS)
1381
1382 if HOST_WIN32
1383 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1384 # This shows up when compiling mono_test_marshal_delegate ()
1385 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1386 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1387 # can't find them. So we use --kill-at to remove the @ suffix as well.
1388 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1389 else
1390 libtest_la_LDFLAGS = -rpath `pwd`
1391 endif
1392 libtest_la_SOURCES = libtest.c
1393 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1394
1395 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat